/*
 * User: Tom
 * Date: 3-aug-2004
 * Time: 0:58:53
 */
package com.tombrus.imageConverter.jobs;

import com.tombrus.imageConverter.JobStep;
import com.tombrus.imageConverter.Job;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Border extends JobStep {
    private static final Pattern pattern   = Pattern.compile("([0-9.]+),([0-9]+),([0-9]+),([0-9]+)");
                         float   thickness;
                         Color   color;

    public int initFrom(Job job,String[] args,int i) {
        i = super.initFrom(job,args,i);
        i++;
        if (args.length <=i) {
            throw new Error("usage: -Border d,r,g,b");
        }
        final Matcher matcher = pattern.matcher(args[i]);
        if (!matcher.matches()) {
            throw new Error("usage: -Border d,r,g,b");
        }
        thickness  =   Float.parseFloat(matcher.group(1));
        color     = new Color(Integer.parseInt(matcher.group(2)),Integer.parseInt(matcher.group(3)),Integer.parseInt(matcher.group(4)));
        return i;
    }

    public void run() {
        final BufferedImage image = getJob().getImage();
        if (image !=null) {
            final Graphics2D g = image.createGraphics();
            g.setColor(color);
            g.setStroke(new BasicStroke(thickness));
            g.draw(new Rectangle.Float(thickness/2,thickness/2,image.getWidth()-thickness,image.getHeight()-thickness));
            g.dispose();
        }
    }
}